<i18n>
{
  "fr": {
    "delete-msg-1": "Suppression",
    "delete-msg-2": "Êtes vous sûr de vouloir supprimer le déplacement domicile / travail",
    "state-1": "Supprimé",
    "state-2": "Valide",
    "state-3": "Extrême",
    "field-1": "Statut",
    "field-2": "Nb jours déplacement",
    "field-3": "Distance moyenne journalière (km)",
    "field-4": "Distance totale annuelle (km)",
    "field-5": "Validité",
    "info-1": "Aucun déplacement domicile / travail",
    "info-2": "Message du répondant",
    "tooltip-1": "Afficher le message",
    "tooltip-2": "Ne pas utiliser le déplacement dans les calculs",
    "tooltip-3": "Utiliser le déplacement dans les calculs"
  },
  "en": {
    "delete-msg-1": "Delete",
    "delete-msg-2": "Are you sure you want to delete the commuting trip",
    "state-1": "Deleted",
    "state-2": "Valid",
    "state-3": "Outlier",
    "field-1": "Position",
    "field-2": "Number of days commuting to work",
    "field-3": "Average daily distance traveled (km)",
    "field-4": "Total annual distance traveled",
    "field-5": "Validity",
    "info-1": "No commute",
    "info-2": "Message from the respondent",
    "tooltip-1": "Afficher le message",
    "tooltip-2": "Do not use commute in calculations",
    "tooltip-3": "Use commute in calculations"
  }
}
</i18n>

<template>
  <div>
    <b-table
      :data="commutes"
      :striped="true"
      :narrowed="true"
      :hoverable="true"
      :sort-icon="'angle-up'"
      paginated
      per-page="20"
      default-sort="isValid"
    >
      <b-table-column
        field="isValid"
        sortable
        :label="$t('field-5')"
        centered
        numeric
        v-slot="props"
      >
        <b-tag rounded v-if="props.row.deleted">{{ $t('state-1') }}</b-tag>
        <b-tag rounded v-else-if="props.row.isValid" type="is-success">{{ $t('state-2') }}</b-tag>
        <b-tag rounded v-else type="is-danger">{{ $t('state-3') }}</b-tag>
      </b-table-column>
      <b-table-column
        field="seqID"
        sortable
        :label="$t('id')"
        centered
        numeric
        v-slot="props"
      >
        <del v-if="props.row.deleted">{{ props.row.seqID }}</del>
        <span v-else>{{ props.row.seqID }}</span>
      </b-table-column>
      <b-table-column
        field="position"
        sortable
        :label="$t('field-1')"
        centered
        numeric
        v-slot="props"
      >
        <del v-if="props.row.deleted">{{ $t(props.row.position) }}</del>
        <span v-else>{{ $t(props.row.position) }}</span>
      </b-table-column>
      <b-table-column
        field="nWorkingDay"
        sortable
        :label="$t('field-2')"
        numeric
        v-slot="props"
      >
        <del v-if="props.row.deleted">{{ props.row.nWorkingDay }}</del>
        <span v-else>{{ props.row.nWorkingDay }}</span>
      </b-table-column>
      <b-table-column
        :label="$t('field-3')"
        numeric
        v-slot="props"
      >
        <del v-if="props.row.deleted">{{ dailyDistance(props.row) | splitNumber }}</del>
        <span v-else>{{ dailyDistance(props.row) | splitNumber }}</span>
      </b-table-column>
      <b-table-column
        :label="$t('field-4')"
        numeric
        v-slot="props"
      >
        <del v-if="props.row.deleted">{{ props.row.getDistanceTotale(GHGIYear) | splitNumber }}</del>
        <span v-else>{{ props.row.getDistanceTotale(GHGIYear) | splitNumber }}</span>
      </b-table-column>
      <b-table-column v-slot="props">
        <div class="panel-block">
          <b-tooltip
            :label="$t('tooltip-1')"
            type="is-black"
          >
            <b-button
              :disabled="!props.row.message"
              size="is-small"
              icon-right="envelope"
              @click="showMessage(props.row)"
            />
          </b-tooltip>
          <b-tooltip
            :label="$t('display')"
            type="is-black"
          >
            <b-button
              size="is-small"
              icon-right="search"
              @click="display(props.row)"
            />
          </b-tooltip>
          <b-tooltip
            v-if="props.row.deleted"
            :label="$t('tooltip-3')"
            type="is-black"
          >
            <b-button
              :disabled="submitted || isClonedSurvey"
              size="is-small"
              icon-right="undo"
              @click="delUndel(props.row)"
            />
          </b-tooltip>
          <b-tooltip
            v-else-if="isEditable"
            :label="$t('delete')"
            type="is-black"
          >
            <b-button
              :disabled="submitted || isClonedSurvey"
              size="is-small"
              icon-right="trash"
              @click="del(props.row)"
            />
          </b-tooltip>
          <b-tooltip
            v-else
            :label="$t('tooltip-2')"
            type="is-black"
          >
            <b-button
              size="is-small"
              :disabled="submitted || isClonedSurvey"
              icon-right="trash"
              @click="delUndel(props.row)"
            />
          </b-tooltip>
        </div>
      </b-table-column>
      <section slot="empty" class="section">
        <div class="content has-text-grey has-text-centered">
          <p>
            <i class="sui sui-ban" style="font-size: 64px"></i>
          </p>
          <p>{{ $t('info-1') }}</p>
        </div>
      </section>
    </b-table>
    <b-modal
      :active.sync="displayModal"
      has-modal-card
      style="z-index:9999"
    >
      <div class="modal-card">
        <header class="modal-card-head">
          <p class="modal-card-title">
            {{ $t('info-2') }}
          </p>
        </header>
        <section class="modal-card-body">
          {{ message }}
        </section>
      </div>
    </b-modal>
  </div>
</template>

<script>
export default {
  name: 'CommutesTable',
  props: {
    isEditable: {
      type: Boolean,
      default: false
    }
  },
  data () {
    return {
      displayModal: false,
      message: null
    }
  },
  computed: {
    GHGIYear: function () {
      return this.$store.getters['ghgi/item']['year']
    },
    commutes: function () {
      return this.$store.getters['commutes/items']
    },
    submitted: function () {
      return this.$store.getters['ghgi/item']['commutesSubmitted']
    },
    isClonedSurvey: function () {
      return this.$store.getters['ghgi/isClonedSurvey']
    }
  },
  watch: {
    commutes: function () {
      if (this.commutes.length === 0) {
        this.$store.commit('commutes/ISVALID', false)
        this.$store.commit(
          'commutes/ISMODIFIED',
          false
        )
      }
    }
  },
  methods: {
    showMessage: function (commute) {
      this.displayModal = true
      this.message = commute.message
    },
    display: function (commute) {
      this.$emit('view', commute)
    },
    dailyDistance: function (deplacement) {
      let distance = 0
      if (deplacement.nWorkingDay > 0) {
        distance = deplacement.getRawWeekDistance() / deplacement.nWorkingDay
      }
      return distance
    },
    delUndel: function (commute) {
      this.$store.dispatch(
        'commutes/deleteUndelete',
        commute
      )
      this.$store.commit(
        'commutes/ISMODIFIED',
        true
      )
    },
    del: function (commute) {
      let self = this
      this.$buefy.dialog.confirm({
        title: self.$t('delete-msg-1'),
        message: self.$t('delete-msg-2') + ' ' + commute.seqID + ' ?',
        confirmText: self.$t('validate'),
        cancelText: self.$t('cancel'),
        canCancel: ['escape', 'button', 'outside'],
        onConfirm: function () {
          self.$store.dispatch(
            'commutes/delete',
            commute
          )
          self.$store.commit(
            'commutes/ISMODIFIED',
            true
          )
        }
      })
    }
  }
}
</script>

<style lang="css">
tr.is-warning {
  background: #fff1f1 !important;
  color: rgba(0, 0, 0, 0.7) !important;
}
.table td {
  vertical-align: middle !important;
}
</style>
